library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity LED7 is
  
  port (
    clk        : in  std_logic;
    reset_n    : in  std_logic;
    write      : in  std_logic;
    chipselect : in  std_logic;
    address    : in  std_logic_vector(2 downto 0);
    writedata  : in  unsigned(7 downto 0);
	HEX0	   : out std_logic_vector(6 downto 0);
	HEX1	   : out std_logic_vector(6 downto 0);
	HEX2	   : out std_logic_vector(6 downto 0);
	HEX3	   : out std_logic_vector(6 downto 0);
	HEX4	   : out std_logic_vector(6 downto 0) 
    );
  
end LED7;

architecture rtl of LED7 is
	type ram_type is array(4 downto 0) of std_logic_vector(6 downto 0);
	signal hex_reg: ram_type;
	signal ram_address: unsigned (2 downto 0);
begin
  HEX0 <= hex_reg(0);HEX1 <= hex_reg(1);HEX2 <= hex_reg(2);
  HEX3 <= hex_reg(3);HEX4 <= hex_reg(4);
  ram_address <= unsigned(address);
  process (clk)
  begin
    if rising_edge(clk) then
      if reset_n = '0' then
        hex_reg(0)<=(others=>'0');hex_reg(1)<=(others=>'0');hex_reg(2)<=(others=>'0');
		hex_reg(3)<=(others=>'0');hex_reg(4)<=(others=>'0');
      else
        if chipselect = '1' then
            if write = '1' then
				hex_reg(to_integer(ram_address)) <= std_logic_vector(writedata(6 downto 0));
            end if;
		end if;
	  end if;
	end if;
  end process;
end rtl;
