library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity switch_reader is
  
  port (
    clk        : in  std_logic;
    reset_n    : in  std_logic;
    read       : in  std_logic;
    chipselect : in  std_logic;
    readdata   : out unsigned(15 downto 0);
	key_status : in std_logic_vector(15 downto 0)
    );
  
end switch_reader;

architecture rtl of switch_reader is
	signal key_status_reg: std_logic_vector (15 downto 0);
  
begin

  process (clk)
  begin
    if rising_edge(clk) then
      if reset_n = '0' then
        key_status_reg <= (others=>'0');
      else
        if chipselect = '1' then
            if  read ='1' then 
					readdata <= unsigned(key_status);
            end if;
		end if;
	  end if;
	end if;
  end process;
end rtl;
