library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity tone_generator is
  
  port (
    avs_s1_clk        : in  std_logic;
    avs_s1_reset_n    : in  std_logic;
    avs_s1_read       : in  std_logic;
    avs_s1_write      : in  std_logic;
    avs_s1_chipselect : in  std_logic;
    avs_s1_address    : in  std_logic;
    avs_s1_readdata   : out unsigned(15 downto 0);
    avs_s1_writedata  : in  unsigned(15 downto 0);
	frq		   : out unsigned(15 downto 0);
	mod_depth  : out unsigned(3 downto 0) 
    );
  
end tone_generator;

architecture rtl of tone_generator is
	signal frq_reg: unsigned(15 downto 0);
	signal mod_depth_reg:unsigned(3 downto 0);
	signal cnt:unsigned(27 downto 0):=x"0000000";
    signal x: std_logic:='0';
	signal y: std_logic:='0';
	signal flag: unsigned(2 downto 0):="011";
	signal clk : std_logic:='0';
  
begin

clk <= avs_s1_clk;

peripheral: process(clk)
  begin
     if rising_edge(clk) then
		if avs_s1_reset_n = '0' then
			avs_s1_readdata <= (others => '0');
		else
          if avs_s1_chipselect = '1' then
             if avs_s1_write = '1' then
                 if avs_s1_address = '0' then  
					flag <= avs_s1_writedata(2 downto 0);
                 end if;
             end if;
          end if;
       end if;
     end if;
end process peripheral;

  process (clk)
  begin
    if rising_edge(clk) then
	--if reset_n = '0' then
	if flag="000" then 
      if (x='0' and y='0') then 
        frq_reg <= x"0951";
		mod_depth_reg <=x"7";
		cnt<=x"0000000";
		frq<=frq_reg;
	    mod_depth<=mod_depth_reg;
	    y <= '1';
		end if;
		
	 if(x='0' and y='1') then
	    cnt <= cnt +1;
			if(cnt = x"2FFFFFF") then
			frq_reg <= x"0597";
		   mod_depth_reg <=x"A";
		    cnt<=x"0000000";		
		frq<=frq_reg;
	    mod_depth<=mod_depth_reg;
		x <= '1';		
			end if;
	end if;	
	
	if(x='1' and y='1') then
	    cnt <= cnt +1;
			if(cnt = x"1FFFFFF") then
		frq_reg <= x"0345";
		   mod_depth_reg <=x"A";
		    cnt<=x"0000000";		
		frq<=frq_reg;
	    mod_depth<=mod_depth_reg;
	     y<='0';
	    end if;
	end if;
	
	if(x='1' and y='0') then
		cnt <= cnt +1;
			if(cnt = x"2FFFFFF") then
		
		x<='0';
		y<='0';
		cnt<=x"0000000";
		end if;
	end if;
		
--     elsif flag="001" then
--	 if (x='0' and y='0') then 
--	   frq_reg <= x"0951";
--		mod_depth_reg <=x"7";
--		cnt<=x"0000000";
--	    frq<=frq_reg;
--	    mod_depth<=mod_depth_reg;
--	     y <= '1';
--		end if;
--		
--	 if(x='0' and y='1') then
--	    cnt <= cnt +1;
--			if(cnt = x"0FFFFFF") then
--			frq_reg <= x"0000";
--		    mod_depth_reg <=x"A";
--		    cnt<=x"0000000";		
--		frq<=frq_reg;
--	    mod_depth<=mod_depth_reg;
--		y <= '0';		
--			end if;
--	end if;	

	elsif flag="001" then 
      if (x='0' and y='0') then 
        frq_reg <= x"0951";
		mod_depth_reg <=x"7";
		cnt<=x"0000000";
		frq<=frq_reg;
	    mod_depth<=mod_depth_reg;
	    y <= '1';
		end if;
		
	 if(x='0' and y='1') then
	    cnt <= cnt +1;
			if(cnt = x"0EFFFFF") then
			frq_reg <= x"0871";
		   mod_depth_reg <=x"A";
		    cnt<=x"0000000";		
		frq<=frq_reg;
	    mod_depth<=mod_depth_reg;
		x <= '1';		
			end if;
	end if;	
	
	if(x='1' and y='1') then
	    cnt <= cnt +1;
			if(cnt = x"0EFFFFF") then
		frq_reg <= x"0751";
		   mod_depth_reg <=x"A";
		    cnt<=x"0000000";		
		frq<=frq_reg;
	    mod_depth<=mod_depth_reg;
	     y<='0';
	    end if;
	end if;
	
	if(x='1' and y='0') then
		cnt <= cnt +1;
			if(cnt = x"0000FFF") then
		
		x<='0';
		y<='0';
		cnt<=x"0000000";
		end if;
	end if;
	
	
elsif flag="010" then
 if (x='0' and y='0') then 
        frq_reg <= x"0971";
		mod_depth_reg <=x"A";
		cnt<=x"0000000";
		frq<=frq_reg;
	    mod_depth<=mod_depth_reg;
	    y <= '1';
		end if;
		
	 if(x='0' and y='1') then
	    cnt <= cnt +1;
			if(cnt = x"08FFFFF") then
			frq_reg <= x"0000";
		   mod_depth_reg <=x"0";
		    cnt<=x"0000000";		
		frq<=frq_reg;
	    mod_depth<=mod_depth_reg;
	    x<='0';
		y<='0';		
			end if;
	end if;	
	
--	if(x='1' and y='1') then
--	    cnt <= cnt +1;
--			if(cnt = x"0FFFFFF") then
--		frq_reg <= x"0718";
--		   mod_depth_reg <=x"A";
--		    cnt<=x"0000000";		
--		frq<=frq_reg;
--	    mod_depth<=mod_depth_reg;
--	     y<='0';
--	    end if;
--	end if;
--	
--	if(x='1' and y='0') then
--		cnt <= cnt +1;
--			if(cnt = x"0FFFFFF") then
--		
--		x<='0';
--		y<='0';
--		cnt<=x"0000000";
--		end if;
--	end if;




 elsif flag="011" then

     if (x='0' and y='0') then 
        frq_reg <= x"0751";
		mod_depth_reg <=x"7";
		cnt<=x"0000000";
		frq<=frq_reg;
	    mod_depth<=mod_depth_reg;
	    y <= '1';
		end if;
		
	 if(x='0' and y='1') then
	    cnt <= cnt +1;
			if(cnt = x"0FFFFFF") then
			frq_reg <= x"0697";
		   mod_depth_reg <=x"A";
		    cnt<=x"0000000";		
		frq<=frq_reg;
	    mod_depth<=mod_depth_reg;
		x <= '1';		
			end if;
	end if;	
	
	if(x='1' and y='1') then
	    cnt <= cnt +1;
			if(cnt = x"0FFFFFF") then
		frq_reg <= x"0545";
		   mod_depth_reg <=x"A";
		    cnt<=x"0000000";		
		frq<=frq_reg;
	    mod_depth<=mod_depth_reg;
	     y<='0';
	    end if;
	end if;
	
	if(x='1' and y='0') then
		cnt <= cnt +1;
			if(cnt = x"0FFFFFF") then
		
		x<='0';
		y<='0';
		cnt<=x"0000000";
		end if;
	end if;




     else 
          x<='0';
		  y<='0';
          frq_reg <= x"0000";
		   mod_depth_reg <=x"0";		
		frq<=frq_reg;
	    mod_depth<=mod_depth_reg;



     end if;
            
			
		
		
--      else
--        if chipselect = '1' then
--            if write = '1' then
--				if address = '0' then 
--				frq_reg <= writedata;
--				elsif  address = '1' then
--				mod_depth_reg(3 downto 0) <= writedata(3 downto 0);
--				end if;
--			elsif read ='1' then 
--				if address='0' then
--				readdata <= frq_reg;
--				elsif  address = '1' then
--				readdata(15 downto 4) <= (others=>'0');
--				readdata(3 downto 0) <= mod_depth_reg(3 downto 0);
--				end if;
--            end if;
--		end if;
	 -- end if;
	end if;
  end process;
	--frq<=frq_reg;
	--mod_depth<=mod_depth_reg;
end rtl;
